#ifndef RaumW_H
#define RaumW_H

#include <qwidget.h>
#include <qpainter.h>
#include <qevent.h>
#include <qcolor.h>
#include <qmessagebox.h>
#include <kmsgbox.h>
#include <qstring.h>
#include <qdatetime.h>
#include <kapp.h>

#include "Dec.h"
#include "cptimer.h"
#include "cprandom.h"

class SteinC: public QWidget
{
	Q_OBJECT
	
	public:
		SteinC(QWidget *parent);
	
		void SteinFarbeSetzen(int Farbe);
		void SteinBlink();
		void Hintergrund();
		
		int Farbe();

	protected:
		virtual void paintEvent(QPaintEvent *PE);

	private:
		void SteinFarbeAendern();

		int MerkFarbe;

};


class Schippe: public QWidget
{

	Q_OBJECT

	public:
		Schippe( QWidget *parent );
		bool Aufnehmen(int);
		int Abwerfen();
		void tipp(int);

		int SchippeStellung();
		void BewegeLinks();
		void BewegeRechts();
		void Stopp();


	public slots:
		//void timerS();
		void timerBS();

	signals:
		void IchHabeMichBewegt();

	protected:
		virtual void resizeEvent (QResizeEvent *E);
		void paintEvent (QPaintEvent *PaintE);

	private:
		SteinC *SchippeStein[5];
		int MerkHoehe;
		CpTimerObj *timerB;
		int Bewegung;
		int BewegungStopp;
		
		int BSi;
		int RestSumme;

};

class RaumW: public QWidget
{

	Q_OBJECT

	public:
		RaumW(QWidget *parent);
		int Punkte; // Points for all Levels
		int klax; // Klax
		int horizo; // horizo
		int PunkteL; // Points for one level
		int diago; //diagonalen
		
		bool LevelAusgabe();
			bool SetzeLevelWerteAufNull();

	public slots:
		void VorSetzen();
		void neuerStein(int,int);
	
	signals:
		void PauseClearFliessband(bool,bool);


	protected:
		void resizeEvent( QResizeEvent *E);
		void keyPressEvent (QKeyEvent *E);	
		void keyReleaseEvent (QKeyEvent *E);	

	private:
		void klaxCheck();
		bool vgl(int,int,int,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2,int=-2);
		void RaumABCheck();
		void RaumAFallCheck();
		void BNullCheck();
		void KannAbwerfen();
		bool Checken;

		int RaumA[5][5];
		int RaumB[5][5];
		
		int Level;
                	int BKlax;
			int BPunkte;
			int BSteine;
			bool NewLevel;
			int PunkteFurFrei;
			int BDiago;
			int APunkte;
		
		SteinC *SteinA[5][5];
		Schippe *SchippeV;

		CpTimerObj *blt;
		int blinkStep;

		QTime *time;
		QTime *time2;
		int BlinkV;

		void fall();
		int fallen;

	private slots:
		void nextBlink();

};


#endif //RaumW_H
